package org.starter.learning;


import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.starter.learning.dao.BookDao;
import org.starter.learning.pojo.Book;
import org.starter.learning.service.BookService;

import java.util.List;

public class AppTest {
    public static void main(String[] args) {
        // 获取IoC容器
        // ApplicationContext 是一个接口需要使用new创建一个对应的实现类对象
        // ClassPathXmlApplicationContext 是一个ApplicationContext的实现，用于从Classpath中的xml获取应用配置
        ClassPathXmlApplicationContext ctx = new ClassPathXmlApplicationContext("applicationContext.xml");
        // 获取Bean
//        BookDao bookDao = (BookDao) ctx.getBean("bookDao");
//        List<Book> bookList = bookDao.getBooks();
//        BookService bookService = (BookService) ctx.getBean("bookService");
//        List<Book> bookList1 = bookService.listBook();
//        BookService bookService1 = (BookService) ctx.getBean("bookService");
//        bookService1.listBook();
//        System.out.println(BookService.class);
//        BookDao bookDao1 = (BookDao) ctx.getBean("bookDao");
//        BookDao bookDao2 = (BookDao) ctx.getBean("bookDao");
//        System.out.println(bookDao1);
//        System.out.println(bookDao2);
        ctx.registerShutdownHook();
        BookDao bookDao = (BookDao) ctx.getBean("bookDao");
        bookDao.getBooks();
//        ctx.close();
    }
}
